# ``Networking``

A delightfully flexible and composable swift networking library.

## Overview

Networking, is a library for building a flexible network stack inside a Swift application. It can be used on any Apple platform. You can use it to provide rich network features such as authenticating, de-duping, throttling and more.

## Topics

### Building Blocks

- ``NetworkingComponent``
- ``NetworkingModifier``

### Authentication

- ``NetworkingComponent/authenticated(with:)``
- ``AuthenticationDelegate``
- ``AuthenticatingCredentials``
- ``AuthenticationMethod``
- ``AuthenticationError``
- ``HeaderBasedAuthentication``
- ``BasicAuthentication``
- ``BasicCredentials``
- ``BearerAuthentication``
- ``BearerCredentials``
